// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from espeak_interfaces:msg/Sentence.idl
// generated code does not contain a copyright notice

#ifndef ESPEAK_INTERFACES__MSG__DETAIL__SENTENCE__STRUCT_HPP_
#define ESPEAK_INTERFACES__MSG__DETAIL__SENTENCE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'settings'
#include "espeak_interfaces/msg/detail/voice_settings__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__espeak_interfaces__msg__Sentence __attribute__((deprecated))
#else
# define DEPRECATED__espeak_interfaces__msg__Sentence __declspec(deprecated)
#endif

namespace espeak_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Sentence_
{
  using Type = Sentence_<ContainerAllocator>;

  explicit Sentence_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : settings(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->text = "";
    }
  }

  explicit Sentence_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : text(_alloc),
    settings(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->text = "";
    }
  }

  // field types and members
  using _text_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _text_type text;
  using _settings_type =
    espeak_interfaces::msg::VoiceSettings_<ContainerAllocator>;
  _settings_type settings;

  // setters for named parameter idiom
  Type & set__text(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->text = _arg;
    return *this;
  }
  Type & set__settings(
    const espeak_interfaces::msg::VoiceSettings_<ContainerAllocator> & _arg)
  {
    this->settings = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    espeak_interfaces::msg::Sentence_<ContainerAllocator> *;
  using ConstRawPtr =
    const espeak_interfaces::msg::Sentence_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<espeak_interfaces::msg::Sentence_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<espeak_interfaces::msg::Sentence_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      espeak_interfaces::msg::Sentence_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<espeak_interfaces::msg::Sentence_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      espeak_interfaces::msg::Sentence_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<espeak_interfaces::msg::Sentence_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<espeak_interfaces::msg::Sentence_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<espeak_interfaces::msg::Sentence_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__espeak_interfaces__msg__Sentence
    std::shared_ptr<espeak_interfaces::msg::Sentence_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__espeak_interfaces__msg__Sentence
    std::shared_ptr<espeak_interfaces::msg::Sentence_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Sentence_ & other) const
  {
    if (this->text != other.text) {
      return false;
    }
    if (this->settings != other.settings) {
      return false;
    }
    return true;
  }
  bool operator!=(const Sentence_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Sentence_

// alias to use template instance with default allocator
using Sentence =
  espeak_interfaces::msg::Sentence_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace espeak_interfaces

#endif  // ESPEAK_INTERFACES__MSG__DETAIL__SENTENCE__STRUCT_HPP_
