// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from espeak_interfaces:msg/VoiceSettings.idl
// generated code does not contain a copyright notice
#include "espeak_interfaces/msg/detail/voice_settings__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `voice_name`
#include "rosidl_runtime_c/string_functions.h"

bool
espeak_interfaces__msg__VoiceSettings__init(espeak_interfaces__msg__VoiceSettings * msg)
{
  if (!msg) {
    return false;
  }
  // amplitude
  msg->amplitude = -1l;
  // word_gap
  msg->word_gap = -1l;
  // pitch
  msg->pitch = -1l;
  // words_per_minute
  msg->words_per_minute = -1l;
  // voice_name
  if (!rosidl_runtime_c__String__init(&msg->voice_name)) {
    espeak_interfaces__msg__VoiceSettings__fini(msg);
    return false;
  }
  {
    bool success = rosidl_runtime_c__String__assign(&msg->voice_name, "");
    if (!success) {
      goto abort_init_0;
    }
  }
  return true;
abort_init_0:
  return false;
}

void
espeak_interfaces__msg__VoiceSettings__fini(espeak_interfaces__msg__VoiceSettings * msg)
{
  if (!msg) {
    return;
  }
  // amplitude
  // word_gap
  // pitch
  // words_per_minute
  // voice_name
  rosidl_runtime_c__String__fini(&msg->voice_name);
}

bool
espeak_interfaces__msg__VoiceSettings__are_equal(const espeak_interfaces__msg__VoiceSettings * lhs, const espeak_interfaces__msg__VoiceSettings * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // amplitude
  if (lhs->amplitude != rhs->amplitude) {
    return false;
  }
  // word_gap
  if (lhs->word_gap != rhs->word_gap) {
    return false;
  }
  // pitch
  if (lhs->pitch != rhs->pitch) {
    return false;
  }
  // words_per_minute
  if (lhs->words_per_minute != rhs->words_per_minute) {
    return false;
  }
  // voice_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->voice_name), &(rhs->voice_name)))
  {
    return false;
  }
  return true;
}

bool
espeak_interfaces__msg__VoiceSettings__copy(
  const espeak_interfaces__msg__VoiceSettings * input,
  espeak_interfaces__msg__VoiceSettings * output)
{
  if (!input || !output) {
    return false;
  }
  // amplitude
  output->amplitude = input->amplitude;
  // word_gap
  output->word_gap = input->word_gap;
  // pitch
  output->pitch = input->pitch;
  // words_per_minute
  output->words_per_minute = input->words_per_minute;
  // voice_name
  if (!rosidl_runtime_c__String__copy(
      &(input->voice_name), &(output->voice_name)))
  {
    return false;
  }
  return true;
}

espeak_interfaces__msg__VoiceSettings *
espeak_interfaces__msg__VoiceSettings__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  espeak_interfaces__msg__VoiceSettings * msg = (espeak_interfaces__msg__VoiceSettings *)allocator.allocate(sizeof(espeak_interfaces__msg__VoiceSettings), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(espeak_interfaces__msg__VoiceSettings));
  bool success = espeak_interfaces__msg__VoiceSettings__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
espeak_interfaces__msg__VoiceSettings__destroy(espeak_interfaces__msg__VoiceSettings * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    espeak_interfaces__msg__VoiceSettings__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
espeak_interfaces__msg__VoiceSettings__Sequence__init(espeak_interfaces__msg__VoiceSettings__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  espeak_interfaces__msg__VoiceSettings * data = NULL;

  if (size) {
    data = (espeak_interfaces__msg__VoiceSettings *)allocator.zero_allocate(size, sizeof(espeak_interfaces__msg__VoiceSettings), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = espeak_interfaces__msg__VoiceSettings__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        espeak_interfaces__msg__VoiceSettings__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
espeak_interfaces__msg__VoiceSettings__Sequence__fini(espeak_interfaces__msg__VoiceSettings__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      espeak_interfaces__msg__VoiceSettings__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

espeak_interfaces__msg__VoiceSettings__Sequence *
espeak_interfaces__msg__VoiceSettings__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  espeak_interfaces__msg__VoiceSettings__Sequence * array = (espeak_interfaces__msg__VoiceSettings__Sequence *)allocator.allocate(sizeof(espeak_interfaces__msg__VoiceSettings__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = espeak_interfaces__msg__VoiceSettings__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
espeak_interfaces__msg__VoiceSettings__Sequence__destroy(espeak_interfaces__msg__VoiceSettings__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    espeak_interfaces__msg__VoiceSettings__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
espeak_interfaces__msg__VoiceSettings__Sequence__are_equal(const espeak_interfaces__msg__VoiceSettings__Sequence * lhs, const espeak_interfaces__msg__VoiceSettings__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!espeak_interfaces__msg__VoiceSettings__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
espeak_interfaces__msg__VoiceSettings__Sequence__copy(
  const espeak_interfaces__msg__VoiceSettings__Sequence * input,
  espeak_interfaces__msg__VoiceSettings__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(espeak_interfaces__msg__VoiceSettings);
    espeak_interfaces__msg__VoiceSettings * data =
      (espeak_interfaces__msg__VoiceSettings *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!espeak_interfaces__msg__VoiceSettings__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          espeak_interfaces__msg__VoiceSettings__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!espeak_interfaces__msg__VoiceSettings__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
