// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from espeak_interfaces:msg/Sentence.idl
// generated code does not contain a copyright notice
#include "espeak_interfaces/msg/detail/sentence__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `text`
#include "rosidl_runtime_c/string_functions.h"
// Member `settings`
#include "espeak_interfaces/msg/detail/voice_settings__functions.h"

bool
espeak_interfaces__msg__Sentence__init(espeak_interfaces__msg__Sentence * msg)
{
  if (!msg) {
    return false;
  }
  // text
  if (!rosidl_runtime_c__String__init(&msg->text)) {
    espeak_interfaces__msg__Sentence__fini(msg);
    return false;
  }
  // settings
  if (!espeak_interfaces__msg__VoiceSettings__init(&msg->settings)) {
    espeak_interfaces__msg__Sentence__fini(msg);
    return false;
  }
  return true;
}

void
espeak_interfaces__msg__Sentence__fini(espeak_interfaces__msg__Sentence * msg)
{
  if (!msg) {
    return;
  }
  // text
  rosidl_runtime_c__String__fini(&msg->text);
  // settings
  espeak_interfaces__msg__VoiceSettings__fini(&msg->settings);
}

bool
espeak_interfaces__msg__Sentence__are_equal(const espeak_interfaces__msg__Sentence * lhs, const espeak_interfaces__msg__Sentence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // text
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->text), &(rhs->text)))
  {
    return false;
  }
  // settings
  if (!espeak_interfaces__msg__VoiceSettings__are_equal(
      &(lhs->settings), &(rhs->settings)))
  {
    return false;
  }
  return true;
}

bool
espeak_interfaces__msg__Sentence__copy(
  const espeak_interfaces__msg__Sentence * input,
  espeak_interfaces__msg__Sentence * output)
{
  if (!input || !output) {
    return false;
  }
  // text
  if (!rosidl_runtime_c__String__copy(
      &(input->text), &(output->text)))
  {
    return false;
  }
  // settings
  if (!espeak_interfaces__msg__VoiceSettings__copy(
      &(input->settings), &(output->settings)))
  {
    return false;
  }
  return true;
}

espeak_interfaces__msg__Sentence *
espeak_interfaces__msg__Sentence__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  espeak_interfaces__msg__Sentence * msg = (espeak_interfaces__msg__Sentence *)allocator.allocate(sizeof(espeak_interfaces__msg__Sentence), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(espeak_interfaces__msg__Sentence));
  bool success = espeak_interfaces__msg__Sentence__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
espeak_interfaces__msg__Sentence__destroy(espeak_interfaces__msg__Sentence * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    espeak_interfaces__msg__Sentence__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
espeak_interfaces__msg__Sentence__Sequence__init(espeak_interfaces__msg__Sentence__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  espeak_interfaces__msg__Sentence * data = NULL;

  if (size) {
    data = (espeak_interfaces__msg__Sentence *)allocator.zero_allocate(size, sizeof(espeak_interfaces__msg__Sentence), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = espeak_interfaces__msg__Sentence__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        espeak_interfaces__msg__Sentence__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
espeak_interfaces__msg__Sentence__Sequence__fini(espeak_interfaces__msg__Sentence__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      espeak_interfaces__msg__Sentence__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

espeak_interfaces__msg__Sentence__Sequence *
espeak_interfaces__msg__Sentence__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  espeak_interfaces__msg__Sentence__Sequence * array = (espeak_interfaces__msg__Sentence__Sequence *)allocator.allocate(sizeof(espeak_interfaces__msg__Sentence__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = espeak_interfaces__msg__Sentence__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
espeak_interfaces__msg__Sentence__Sequence__destroy(espeak_interfaces__msg__Sentence__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    espeak_interfaces__msg__Sentence__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
espeak_interfaces__msg__Sentence__Sequence__are_equal(const espeak_interfaces__msg__Sentence__Sequence * lhs, const espeak_interfaces__msg__Sentence__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!espeak_interfaces__msg__Sentence__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
espeak_interfaces__msg__Sentence__Sequence__copy(
  const espeak_interfaces__msg__Sentence__Sequence * input,
  espeak_interfaces__msg__Sentence__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(espeak_interfaces__msg__Sentence);
    espeak_interfaces__msg__Sentence * data =
      (espeak_interfaces__msg__Sentence *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!espeak_interfaces__msg__Sentence__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          espeak_interfaces__msg__Sentence__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!espeak_interfaces__msg__Sentence__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
