// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from espeak_interfaces:msg/VoiceSettings.idl
// generated code does not contain a copyright notice

#ifndef ESPEAK_INTERFACES__MSG__DETAIL__VOICE_SETTINGS__FUNCTIONS_H_
#define ESPEAK_INTERFACES__MSG__DETAIL__VOICE_SETTINGS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "espeak_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "espeak_interfaces/msg/detail/voice_settings__struct.h"

/// Initialize msg/VoiceSettings message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * espeak_interfaces__msg__VoiceSettings
 * )) before or use
 * espeak_interfaces__msg__VoiceSettings__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
bool
espeak_interfaces__msg__VoiceSettings__init(espeak_interfaces__msg__VoiceSettings * msg);

/// Finalize msg/VoiceSettings message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
void
espeak_interfaces__msg__VoiceSettings__fini(espeak_interfaces__msg__VoiceSettings * msg);

/// Create msg/VoiceSettings message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * espeak_interfaces__msg__VoiceSettings__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
espeak_interfaces__msg__VoiceSettings *
espeak_interfaces__msg__VoiceSettings__create();

/// Destroy msg/VoiceSettings message.
/**
 * It calls
 * espeak_interfaces__msg__VoiceSettings__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
void
espeak_interfaces__msg__VoiceSettings__destroy(espeak_interfaces__msg__VoiceSettings * msg);

/// Check for msg/VoiceSettings message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
bool
espeak_interfaces__msg__VoiceSettings__are_equal(const espeak_interfaces__msg__VoiceSettings * lhs, const espeak_interfaces__msg__VoiceSettings * rhs);

/// Copy a msg/VoiceSettings message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
bool
espeak_interfaces__msg__VoiceSettings__copy(
  const espeak_interfaces__msg__VoiceSettings * input,
  espeak_interfaces__msg__VoiceSettings * output);

/// Initialize array of msg/VoiceSettings messages.
/**
 * It allocates the memory for the number of elements and calls
 * espeak_interfaces__msg__VoiceSettings__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
bool
espeak_interfaces__msg__VoiceSettings__Sequence__init(espeak_interfaces__msg__VoiceSettings__Sequence * array, size_t size);

/// Finalize array of msg/VoiceSettings messages.
/**
 * It calls
 * espeak_interfaces__msg__VoiceSettings__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
void
espeak_interfaces__msg__VoiceSettings__Sequence__fini(espeak_interfaces__msg__VoiceSettings__Sequence * array);

/// Create array of msg/VoiceSettings messages.
/**
 * It allocates the memory for the array and calls
 * espeak_interfaces__msg__VoiceSettings__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
espeak_interfaces__msg__VoiceSettings__Sequence *
espeak_interfaces__msg__VoiceSettings__Sequence__create(size_t size);

/// Destroy array of msg/VoiceSettings messages.
/**
 * It calls
 * espeak_interfaces__msg__VoiceSettings__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
void
espeak_interfaces__msg__VoiceSettings__Sequence__destroy(espeak_interfaces__msg__VoiceSettings__Sequence * array);

/// Check for msg/VoiceSettings message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
bool
espeak_interfaces__msg__VoiceSettings__Sequence__are_equal(const espeak_interfaces__msg__VoiceSettings__Sequence * lhs, const espeak_interfaces__msg__VoiceSettings__Sequence * rhs);

/// Copy an array of msg/VoiceSettings messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
bool
espeak_interfaces__msg__VoiceSettings__Sequence__copy(
  const espeak_interfaces__msg__VoiceSettings__Sequence * input,
  espeak_interfaces__msg__VoiceSettings__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // ESPEAK_INTERFACES__MSG__DETAIL__VOICE_SETTINGS__FUNCTIONS_H_
