// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from espeak_interfaces:msg/VoiceSettings.idl
// generated code does not contain a copyright notice

#ifndef ESPEAK_INTERFACES__MSG__DETAIL__VOICE_SETTINGS__STRUCT_HPP_
#define ESPEAK_INTERFACES__MSG__DETAIL__VOICE_SETTINGS__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__espeak_interfaces__msg__VoiceSettings __attribute__((deprecated))
#else
# define DEPRECATED__espeak_interfaces__msg__VoiceSettings __declspec(deprecated)
#endif

namespace espeak_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VoiceSettings_
{
  using Type = VoiceSettings_<ContainerAllocator>;

  explicit VoiceSettings_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->amplitude = -1l;
      this->word_gap = -1l;
      this->pitch = -1l;
      this->words_per_minute = -1l;
      this->voice_name = "";
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->amplitude = 0l;
      this->word_gap = 0l;
      this->pitch = 0l;
      this->words_per_minute = 0l;
      this->voice_name = "";
    }
  }

  explicit VoiceSettings_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : voice_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->amplitude = -1l;
      this->word_gap = -1l;
      this->pitch = -1l;
      this->words_per_minute = -1l;
      this->voice_name = "";
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->amplitude = 0l;
      this->word_gap = 0l;
      this->pitch = 0l;
      this->words_per_minute = 0l;
      this->voice_name = "";
    }
  }

  // field types and members
  using _amplitude_type =
    int32_t;
  _amplitude_type amplitude;
  using _word_gap_type =
    int32_t;
  _word_gap_type word_gap;
  using _pitch_type =
    int32_t;
  _pitch_type pitch;
  using _words_per_minute_type =
    int32_t;
  _words_per_minute_type words_per_minute;
  using _voice_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _voice_name_type voice_name;

  // setters for named parameter idiom
  Type & set__amplitude(
    const int32_t & _arg)
  {
    this->amplitude = _arg;
    return *this;
  }
  Type & set__word_gap(
    const int32_t & _arg)
  {
    this->word_gap = _arg;
    return *this;
  }
  Type & set__pitch(
    const int32_t & _arg)
  {
    this->pitch = _arg;
    return *this;
  }
  Type & set__words_per_minute(
    const int32_t & _arg)
  {
    this->words_per_minute = _arg;
    return *this;
  }
  Type & set__voice_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->voice_name = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    espeak_interfaces::msg::VoiceSettings_<ContainerAllocator> *;
  using ConstRawPtr =
    const espeak_interfaces::msg::VoiceSettings_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<espeak_interfaces::msg::VoiceSettings_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<espeak_interfaces::msg::VoiceSettings_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      espeak_interfaces::msg::VoiceSettings_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<espeak_interfaces::msg::VoiceSettings_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      espeak_interfaces::msg::VoiceSettings_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<espeak_interfaces::msg::VoiceSettings_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<espeak_interfaces::msg::VoiceSettings_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<espeak_interfaces::msg::VoiceSettings_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__espeak_interfaces__msg__VoiceSettings
    std::shared_ptr<espeak_interfaces::msg::VoiceSettings_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__espeak_interfaces__msg__VoiceSettings
    std::shared_ptr<espeak_interfaces::msg::VoiceSettings_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VoiceSettings_ & other) const
  {
    if (this->amplitude != other.amplitude) {
      return false;
    }
    if (this->word_gap != other.word_gap) {
      return false;
    }
    if (this->pitch != other.pitch) {
      return false;
    }
    if (this->words_per_minute != other.words_per_minute) {
      return false;
    }
    if (this->voice_name != other.voice_name) {
      return false;
    }
    return true;
  }
  bool operator!=(const VoiceSettings_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VoiceSettings_

// alias to use template instance with default allocator
using VoiceSettings =
  espeak_interfaces::msg::VoiceSettings_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace espeak_interfaces

#endif  // ESPEAK_INTERFACES__MSG__DETAIL__VOICE_SETTINGS__STRUCT_HPP_
